=== debian/changelog ===
beignet (1.1.2-5) unstable; urgency=medium

  * Stop build-depending on LLVM 3.7 on release architectures.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Wed, 17 Aug 2016 22:34:29 +0100

beignet (1.1.2-4) unstable; urgency=medium

  * Fix build with GCC 6. (Closes: #831196)
  * Fix broken internal links in documentation.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Fri, 15 Jul 2016 07:47:59 +0100

beignet (1.1.2-3) unstable; urgency=medium

  * Make profiling work on multiarch systems.
  * Return failure (instead of asserting) on input containing
    unresolvable function calls.
  * Update update-docs.patch.
  * Convert documentation to HTML.
  * Move most documentation to beignet-dev.
  * Register documentation in doc-base.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sat, 18 Jun 2016 19:21:38 +0100

beignet (1.1.2-2) unstable; urgency=medium

  [ Andreas Beckmann ]
  * Drop the -dbg package in favor of autogenerated -dbgsym packages.

  [ Rebecca N. Palmer ]
  * Remove SSE(2) #defines to fix i386 FTBFS. (Closes: #823438)
  * Make test runner work on i386.
  * Enable debug output in profiling_exec test.
  * Re-add find-python35.patch: kfreebsd-* still needs it.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Wed, 04 May 2016 20:47:54 +0100

beignet (1.1.2-1) unstable; urgency=medium

  * New upstream release.
  * Drop patches applied upstream, refresh others.
  * Drop find-python35.patch: this has now been fixed in cmake.
  * Use same LLVM/Clang version as mesa.
  * Use https in Vcs-Git and Homepage.
  * Bump Standards-Version to 3.9.8 (no changes needed).
  * Enable bindnow hardening.
  * Update and sort d/copyright.
  * Improve reportbug script.
  * Update/clarify update-docs.patch and package description
    (mostly what hardware is supported).
  * Use std::isnan/isinf to fix Ubuntu FTBFS.
  * Add LLVM 3.8 support.

 -- Rebecca N. Palmer <rebecca_palmer@zoho.com>  Sat, 30 Apr 2016 23:04:19 +0100
